package com.baijiayun.groupclassui.base

import android.app.Dialog
import android.os.Bundle
import android.view.Gravity
import android.view.WindowManager
import androidx.core.content.ContextCompat
import com.baijiayun.bjyutils.kt.dp
import com.baijiayun.groupclassui.R
import com.baijiayun.groupclassui.chat.preview.IChatMessageCallback
import com.baijiayun.livebase.base.BaseDialogFragment
import com.baijiayun.liveuibase.utils.ToastUtil

/**
 * Created by yongjiaming on 2018/10/15
 */
abstract class BaseGroupDialogFragment : BaseDialogFragment() {
    private var offsetY = 0
    var callback: IChatMessageCallback? = null

    override fun onCreateDialog(savedInstanceState: Bundle?): Dialog {
        return Dialog(context!!)
    }

    protected open fun hideUIMenu(): Boolean {
        return true
    }

    override fun getContentBackgroundColor(): Int {
        return ContextCompat.getColor(contextReference, R.color.bjysc_half_black)
    }

    override fun setWindowParams(windowParams: WindowManager.LayoutParams) {
        if (hideUIMenu()) {
            dialog?.window?.run {
                com.baijiayun.bjyutils.screen.DisplayUtils.hideBottomUIMenu(this)
            }
        }
        arguments?.run {
            offsetY = getInt(OFFSET_Y)
        }
        windowParams.width = 330.dp
        windowParams.height = com.baijiayun.bjyutils.screen.DisplayUtils.getScreenHeightPixels(context!!) - offsetY
        windowParams.y = offsetY
        windowParams.gravity = Gravity.START or Gravity.TOP
    }

    override fun showToast(msg: String) {
        ToastUtil(context).setText(msg).show()
    }

    override fun onDestroy() {
        super.onDestroy()
        if (callback != null) {
            callback = null
        }
    }

    fun setChatMsgCallback(callback: IChatMessageCallback?) {
        this.callback = callback
    }

    companion object {
        protected const val OFFSET_Y = "offsetY"
    }
}