package com.baijiayun.groupclassui.container;

import android.content.Context;
import android.os.Build;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.annotation.RequiresApi;
import android.util.AttributeSet;
import android.view.ViewGroup;
import android.widget.FrameLayout;

import com.baijiayun.groupclassui.layer.FullScreenLayer;
import com.baijiayun.groupclassui.widget.DragRelativeLayout;
import com.baijiayun.groupclassui.window.toolbar.ToolbarWindow;

/**
 * Created by Shubo on 2018/10/11.
 */
public class FullScreenContainer extends FrameLayout {

    private FullScreenLayer mFullScreenLayer;

    public FullScreenContainer(@NonNull Context context) {
        this(context, null);
    }

    public FullScreenContainer(@NonNull Context context, @Nullable AttributeSet attrs) {
        this(context, attrs, 0);
    }

    public FullScreenContainer(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        init();
    }

    @RequiresApi(api = Build.VERSION_CODES.LOLLIPOP)
    public FullScreenContainer(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr, int defStyleRes) {
        super(context, attrs, defStyleAttr, defStyleRes);
        init();
    }

    private void init() {

        mFullScreenLayer = new FullScreenLayer(getContext());

        addView(mFullScreenLayer, new FrameLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
    }

    public ToolbarWindow getToolBarVindow() {
        if (mFullScreenLayer == null)
            return null;
        return mFullScreenLayer.getToolBarWindow();
    }

    public void addToolbarWindow() {
        if (mFullScreenLayer != null) {
            mFullScreenLayer.addView(getToolBarVindow().getView());
        }
    }

    public void setOnUpdateLayoutParamsListener(DragRelativeLayout.OnUpdateLayoutParamsListener listener) {
        if (mFullScreenLayer == null)
            return;
        mFullScreenLayer.setOnUpdateLayoutParamsListener(listener);
    }
}
