package com.baijiayun.groupclassui.util;

/**
 * Created by pengwenjian on 2020/12/7
 * Describe:
 */
public class LayoutUtils {
    /**
     * 根据 childCount 计算每行最多个数
     */
    public static int getMaxNumPerLine(int childCount) {
        if (childCount <= 2) {
            return childCount;
        } else if (childCount <= 8) {
            return childCount / 2 + (childCount % 2 > 0 ? 1 : 0);
        } else if (childCount <= 12) {
            return childCount / 3 + (childCount % 3 > 0 ? 1 : 0);
        } else if (childCount <= 16) {
            return 4;
        } else {
            //专业小班课一般不超过16个人上台
            return (int) Math.floor(Math.sqrt(childCount));
        }
    }

    /**
     * 根据 childCount 计算行数
     */
    public static int getLineCount(int sourceCount) {
        final int columnCount = getMaxNumPerLine(sourceCount);
        return sourceCount / columnCount + (sourceCount % columnCount > 0 ? 1 : 0);
    }

}
