package com.baijiayun.groupclassui.window.toolbar;

import com.baijiayun.groupclassui.global.EventKey;
import com.baijiayun.groupclassui.global.IRouter;
import com.baijiayun.liveuibase.widgets.courseware.models.UploadingImageModel;

import java.util.List;
import java.util.concurrent.LinkedBlockingQueue;


public class ToolbarPresenter implements ToolbarContract.ToolbarPresenter{

    private ToolbarContract.ToolbarView view;

    private IRouter iRouter;

    private LinkedBlockingQueue<UploadingImageModel> uploadingImageQueue;

    ToolbarPresenter(ToolbarContract.ToolbarView view){
        this.view = view;
    }

    @Override
    public void setRouter(IRouter router) {
        iRouter = router;
        uploadingImageQueue = new LinkedBlockingQueue<>();
        subscribe();
    }

    @Override
    public void subscribe() {
        // do nothing
    }

    @Override
    public void unSubscribe() {
        // do nothing
    }

    @Override
    public void destroy() {
        iRouter = null;
    }

    @Override
    public void selectMode(boolean isSelectMode) {
        iRouter.getSubjectByKey(EventKey.SelectModeEnable).onNext(isSelectMode);
    }

    @Override
    public void lineDrawMode(List<Object> data) {
        iRouter.getSubjectByKey(EventKey.DrawLineModeEnable).onNext(data);
    }

    @Override
    public void graphDrawMode() {
        // do nothing
    }

    @Override
    public void laserDrawMode() {
        // do nothing
    }

    @Override
    public void wordEditMode() {
        // do nothing
    }

    @Override
    public void sendImageShape(String path) {
        UploadingImageModel model = new UploadingImageModel(path, null, null);
        uploadingImageQueue.offer(model);
        continueUploadQueue();
    }

    @Override
    public void eraseShape() {
        // do nothing
    }

    @Override
    public void documentManage() {
        // do nothing
    }

    @Override
    public void teachingAid() {
        // do nothing
    }

    @Override
    public void groupManage() {
        iRouter.getSubjectByKey(EventKey.GroupManageLayout).onNext(true);
    }

    private void continueUploadQueue(){
        // do nothing
    }
}
